<?php
/**
 * 
 * MemberMouse(TM) (http://www.membermouse.com)
 * (c) MemberMouse, LLC. All rights reserved.
 *
 */
class MM_FacebookLoginExtension extends MM_AbstractSocialLoginExtension
{	
	
	protected $extensionName = "Login with Facebook";
	protected $providerName  = "Facebook";
	protected $keyName		 = "App ID";
	protected $secretName 	 = "App Secret";
	
	public function __construct($autoloadDependencies=true,$configData="") 
	{ 
		//facebook specific settings
		$this->token = MM_Extension::$FACEBOOK_LOGIN_TOKEN;
		$this->listingImage = "https://membermouse.com/assets/plugin_images/logos/extensions-fb.jpg";
	 	$this->supportArticleUrl = "https://membermouse.com/docs/configuring-facebook-login";
		parent::__construct($autoloadDependencies,$configData);
	}
	
	
	protected function getHybridAuthConfig()
	{
		$config = parent::getHybridAuthConfig();
		$config["providers"] = array (
					$this->token => array (
							"enabled" => true,
							"keys"    => array ( "id" => $this->apiKey, "secret" => $this->apiSecret ),
							"scope"   => "email",
							
					)
			);
		return $config;
	}
}
