<?php
/**
 * 
 * MemberMouse(TM) (http://www.membermouse.com)
 * (c) MemberMouse, LLC. All rights reserved.
 *
 */
class MM_LinkedInLoginExtension extends MM_AbstractSocialLoginExtension
{	
	
	protected $extensionName = "Login with LinkedIn";
	protected $providerName  = "LinkedIn";
	protected $keyName		 = "Client ID";
	protected $secretName 	 = "Client Secret";
	
	public function __construct($autoloadDependencies=true,$configData="") 
	{ 
		//linkedin specific settings
		$this->token = MM_Extension::$LINKEDIN_LOGIN_TOKEN;
		$this->listingImage = "https://membermouse.com/assets/plugin_images/logos/extensions-linkedin.jpg";
	 	$this->supportArticleUrl = "https://membermouse.com/docs/configuring-linkedin-login";
		parent::__construct($autoloadDependencies,$configData);
	}
	
	
	protected function getHybridAuthConfig()
	{
		$config = parent::getHybridAuthConfig();
		$config["providers"] = array (
					$this->token => array (
							"enabled" => true,
							"keys"    => array ( "id" => $this->apiKey, "secret" => $this->apiSecret ), 
							"scope"   => "r_emailaddress r_liteprofile",
							
					)
			);
		return $config;
	}
}
