<?php
/**
 * 
 * MemberMouse(TM) (http://www.membermouse.com)
 * (c) MemberMouse, LLC. All rights reserved.
 *
 */
class MM_TwitterLoginExtension extends MM_AbstractSocialLoginExtension
{	
	
	public function __construct($autoloadDependencies=true,$configData="") 
	{ 
		//twitter specific settings
		$this->token = MM_Extension::$TWITTER_LOGIN_TOKEN;
		$this->listingImage  = "https://membermouse.com/assets/plugin_images/logos/extensions-twitter.jpg";
		$this->extensionName = "Login with Twitter";
		$this->providerName  = "Twitter";
		$this->keyName       = "API Key";
		$this->secretName    = "API Secret";
		$this->providesEmail = false;
	 	$this->supportArticleUrl = "https://membermouse.com/docs/configuring-twitter-login";
		parent::__construct($autoloadDependencies,$configData);
	}
	
	protected function getHybridAuthConfig()
	{
		$config = parent::getHybridAuthConfig();
		$config["providers"] = array (
				$this->token => array (
						"enabled" => true,
						"keys"    => array ( "key" => $this->apiKey, "secret" => $this->apiSecret )							
				)
		);
		return $config;
	}
	
	
	public function displayConfigScreen()
	{
		$callbackUrl = $this->libraryUrl."/";
		$this->additionalInfo = "<tr>
				<td NOWRAP>Callback URL</td>
				<td NOWRAP>
					<span style='font-family:courier; font-size:11px;'>
					<input id='mm-twitter-callback-url' type='text' readonly value='{$callbackUrl}' style='width:600px' onclick=\"jQuery('#mm-google-callback-url').focus(); jQuery('#mm-google-callback-url').select();\" />
					</span>
				</td>
			</tr>\n";
		return parent::displayConfigScreen();	
	}
}
