<?php
/**
 * 
 * MemberMouse(TM) (http://www.membermouse.com)
 * (c) MemberMouse, LLC. All rights reserved.
 */
class MM_CountrySubdivisionUtils
{			
	/**
	 * This returns all subdivisions (states, provinces, etc...) within desired country
	 */
	public static function getCountrySubdivsionList($iso=array())
	{
		global $wpdb;
	
    $iso = (array)$iso;
    
		$sql = "SELECT `iso`, `code`, `name` from ".MM_TABLE_COUNTRY_SUBDIVISIONS." WHERE `iso` IN ('".implode("','", $iso)."') order by name asc";
		
		$results = $wpdb->get_results($sql, OBJECT);
		$list = array();
	
		foreach ($results as $iso => $row)
		{
		  $list[$row->iso][$row->code] = $row->name;
		}
	
		return $list;
	}
	
	public static function getCountrySubdivsionName($iso, $code)
	{
		global $wpdb;
		
		$sql = "SELECT `name` from ".MM_TABLE_COUNTRY_SUBDIVISIONS." where `iso` = '{$iso}' AND `code` = '{$code}' limit 1;";
		$row = $wpdb->get_row($sql);
		
		if(isset($row->name))
		{
			return $row->name;
		}
		else
		{
			return "{$iso}-{$code}";	
		}
	}
	
	/**
	 * This function takes country code and a state code and returns the text version of the state name
	 * 
	 * @param String $country country code
	 * @param String $state state code
	 * @return String the state name
	 */
	public static function getStateName($country, $state)
	{
	    $states = MM_CountrySubdivisionUtils::getCountrySubdivsionList(array($country));
	    if(isset($states[$country]) && !is_null($states[$country]))
	    {
	        if(isset($states[$country][$state]) && !is_null($states[$country][$state]))
	        {
	            return $states[$country][$state];
	        }
	    }
	    return "";
	}
}
?>