<?php
/**
 *
 * MemberMouse(TM) (http://www.membermouse.com)
 * (c) MemberMouse, LLC. All rights reserved.
 */

if(isset($_REQUEST["mm-update-license"]))
{
	MM_MemberMouseService::authorize();
}

$license = MM_License::getCurrentLicense();

$data = [];
$data["Name"] = $license->getName();
$data["URL"] = $license->getUrl();
$data["Version"] = $license->getMajorVersion();
$data["License Type"] = $license->getLicenseType() . (($license->isStaging()) ? " (staging)" : "");
$data["Last Updated"] = date('M j, Y g:i a', strtotime($license->getLastUpdated()));

$dataGrid = new MM_DataGrid($_REQUEST, "id", "desc", 10);
$dataGrid->showPagingControls = false;
$dataGrid->setTotalRecords(count($data));
$dataGrid->width = "500px";
$dataGrid->recordName = "license details";

$licenseStatus = ($license->isUnlicensed() === true) ? _mmt("Unregistered License") : _mmt("Registered License");


$headers = [ 'col1'		=> [ 'content' => $licenseStatus ],
             'col2'	    => [ 'content' => '&nbsp'   ] ];

$rows = [];
foreach($data as $key=>$item)
{
    $rows[] = array
    (
        array('content' => $key),
        array('content' => $item)
    );
}

$dataGrid->setHeaders($headers);
$dataGrid->setRows($rows);

$dgHtml = $dataGrid->generateHtml();

?>
<div class="mm-wrap">
    <p class="mm-header-text">License Information</p>
    <div style="clear:both; height: 10px;"></div>
	
	<?php echo $dgHtml; ?>
	<div style="clear:both; height: 10px;"></div>
	<!-- License ID: <?php echo $license->getId(); ?> -->
	<form method="post">
		<input type="hidden" name="mm-update-license" value="1" />
		<input type='submit' value='Refresh License' class="mm-ui-button blue" />
	</form>
</div>