<?php
/**
 *
 * MemberMouse(TM) (http://www.membermouse.com)
 * (c) MemberMouse, LLC. All rights reserved.
 */

$blockUIScriptUrl = plugins_url(MM_PLUGIN_NAME."/resources/js/common/jquery.blockUI.js");
wp_enqueue_script("membermouse-blockUI", $blockUIScriptUrl, array('jquery'), MemberMouse::getPluginVersion(), true);

$migrationWarningMsg = "Your site has been upgraded to MemberMouse version ".MemberMouse::getPluginVersion()." from a previous version. ".
	"To ensure a seamless transition and optimal performance, your database tables need to be upgraded. ".
	"Please create a full site backup before proceeding with the database upgrade.";

$supportInfoMsg = "For more information, please see ";
$supportLinkTitle = "Important Changes for MemberMouse 3.0";
$supportUrl = "https://membermouse.com/docs/important-changes-for-membermouse-3-0-read-this-first/#database-upgrade";

?>
<div class="mm-wrap">
    <p class="mm-header-text"><?php echo _mmt("Upgrade Database Tables"); ?></p>
	<div style="width:645px;">
	<?php if (!mmShouldUseLegacyDB()) { ?>
		<p><?php echo _mmt("Your database has already been upgraded"); ?></p>
	<?php } else { ?>
    		<div style="width:750px;" class="mm-info-box yellow">
	        	<form id="db-migration-form">
		        	<p><i class="fa fa-exclamation-triangle" style="color:#eed202"></i> <strong><?php echo _mmt($migrationWarningMsg); ?></strong></p>
		        	<p><?php echo _mmt($supportInfoMsg) . '<a target="_blank" href="' . $supportUrl . '">' . _mmt($supportLinkTitle) . '</a>.'; ?></p>
		        	<div class="mm-button-container">
		        		<input type="checkbox" name="migrate-collation" id="migrate-collation" checked=CHECKED > Also change table collation (recommended). This will clear the Activity Log.
		        	</div>
		        	<div class="mm-button-container">
		        		<a id="do-migration" class="mm-ui-button green"><?php echo _mmt("Begin Upgrade"); ?></a>
		        	</div>
	        	</form>
        	</div>
    	<?php } ?>
	</div>
</div>
<div class="mbtDialog" id="mm-migration-progress-dialog" style='display:none'>
    <h3><i class="fa fa-download" style="top:1px;"></i>  <?php echo _mmt("Database Upgrade"); ?></h3>
    <p><?php echo _mmt("Your database is being upgraded."); ?></p>
    <p><em><?php echo _mmt("Please do not close this window or navigate away from this page until the process is complete."); ?></em></p>
    <div>
    	<label for="mm-migration-progress"><?php echo _mmt("Upgrade progress"); ?>:</label>
		<progress id="mm-migration-progress" value="0" max="100"></progress>
		<br>
		<div id="mm-migration-progress-text"></div>
	</div> 	
    <p>
    	<input type='button' value="OK" id="mm-migration-ok" class="mm-ui-button" style="display:none" />
    </p>
</div>
