/*!
 * 
 * MemberMouse(TM) (http://www.membermouse.com)
 * (c) MemberMouse, LLC. All rights reserved.
 */
var MM_JobsQueueLogViewJS = MM_EnhancedDatagridView.extend({
	
	storeJobStateSearchOptions: function()
	{
		this.module = "MM_JobsQueueLogView";
		this.method = "performAction";
		this.action = "module-handle";
		  
		var values = {
			mm_action: "storeJobStateSearchOptions",
			mm_admin_id: jQuery("#mm-admin-id").val(),
			mm_show_failed_jobs: (jQuery("#mm-show-failed-jobs").val() === "failed") ? 1 : 0
		}
		
		 var ajax = new MM_Ajax(false, this.module, this.action, this.method);
		 ajax.useLoader = true;
		 ajax.send(values, false, 'mmjs', "storeSearchOptionsCallback"); 
	},
	
	
	storeSearchOptionsCallback: function(data)
	{
		if(data == undefined)
		{
			alert("No response received");
		}
		else if(data.type == "error")
		{
			alert(data.message);
		}
		else
		{
			// reload grid
			mmjs.grid.dumpCacheAndRefresh();
		}
	},
		
	 renderGrid: function(imageList,translationList)
	 {
		jQuery(document).ready(function() {
			let gridConfig = { "columns" : [ { "id": "id", "name":"ID", "sortable":true, "searchType":"numeric", "defaultSortType":"DESC" },
											 { "id": "runtime", "name":"Run Time", "sortable":true, "searchType": "date", "defaultSearchField":true },
											 { "id": "firstrun", "name":"First Run", "sortable":true, "searchType": "date" },
											 { "id": "lastrun", "name":"Last Run", "searchType": "date" },
											 { "id": "priority", "name":"Priority", "searchType":"numeric" },
											 { "id": "tries", "name":"Tries", "sortable":true, "searchType":"numeric" },
											 { "id": "reason", "name":"Reason", "sortable":true },
											 { "id": "status", "name":"Status", "sortable":true },
											 { "id": "created_at", "name":"Created At", "sortable":true, "searchType": "date" },
											// { "id": "actions", "name":"Actions", "render":mmjs.renderActions }
											],
							   "version"    : 1, //MUST increment this every time the column definitions change!
							   "datasource" : mmjs.search.bind(mmjs) 
				};
			grid = new MM_EnhancedDatagridJS(document.getElementById("gridHolder"),"job",gridConfig);
			grid.bulkOperationsEnabled = false;
			grid.ajaxSearchEnabled = false;
			
			if (imageList)
			{
				grid.setImageReferences(imageList);
			}
			if (translationList)
			{
				grid.setTranslationObject(translationList);
			}
			grid.render();
			mmjs.setGrid(grid);
		});
	 },

	 bindEventListeners: function()
	 {
		let el = document.querySelector("#mm-show-failed-jobs");
	 	el.addEventListener('click', () => {
			 mmjs.storeJobStateSearchOptions();
		 });
	 }
});

var mmjs = new MM_JobsQueueLogViewJS("MM_JobsQueueLogView", "Jobs Queue Log");